Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 325277 - net-analyzer/tcptrace-6.6.7 cannot be built anymore.
Summary: net-analyzer/tcptrace-6.6.7 cannot be built anymore.
Status: VERIFIED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: New packages (show other bugs)
Hardware: All Linux
: High normal (vote)
Assignee: Netmon Herd
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2010-06-24 00:30 UTC by Nico Baggus
Modified: 2010-07-27 21:13 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Nico Baggus 2010-06-24 00:30:31 UTC
x86_64-pc-linux-gnu-gcc -O2 -O2 -pipe -mno-tls-direct-seg-refs -g  -DGUNZIP="\"gunzip\"" -DBUNZIP2="\"bunzip2\"" -DLOAD_MODULE_HTTP -DHTTP_SAFE -DHTTP_DUMP_TIMES -DLOAD_MODULE_TRAFFIC -DLOAD_MODULE_SLICE -DLOAD_MODULE_RTTGRAPH -DLOAD_MODULE_COLLIE -DLOAD_MODULE_REALTIME -DGROK_SNOOP -DGROK_TCPDUMP -DGROK_NETM -DGROK_ETHERPEEK -DGROK_NS -DGROK_NETSCOUT -DGROK_ERF -DYYTEXT_POINTER=1 -DHAVE_LIBM=1 -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DSIZEOF_UNSIGNED_LONG_LONG_INT=8 -DSIZEOF_UNSIGNED_LONG_INT=8 -DSIZEOF_UNSIGNED_INT=4 -DSIZEOF_UNSIGNED_SHORT=2 -DHAVE_MKSTEMP=1 -DHAVE_VALLOC=1 -DHAVE_MEMALIGN=1 -DHAVE_INET_PTON=1 -DUSE_LLU=1   -I.  -I/usr/local/include -I. -I../pcap -I/usr/include/pcap   -c -o plotter.o plotter.c                                                                               
plotter.c: In function 'plotter_done':                                                                                                                        
plotter.c:402: warning: ignoring return value of 'system', declared with attribute warn_unused_result                                                         
x86_64-pc-linux-gnu-gcc -O2 -O2 -pipe -mno-tls-direct-seg-refs -g  -DGUNZIP="\"gunzip\"" -DBUNZIP2="\"bunzip2\"" -DLOAD_MODULE_HTTP -DHTTP_SAFE -DHTTP_DUMP_TIMES -DLOAD_MODULE_TRAFFIC -DLOAD_MODULE_SLICE -DLOAD_MODULE_RTTGRAPH -DLOAD_MODULE_COLLIE -DLOAD_MODULE_REALTIME -DGROK_SNOOP -DGROK_TCPDUMP -DGROK_NETM -DGROK_ETHERPEEK -DGROK_NS -DGROK_NETSCOUT -DGROK_ERF -DYYTEXT_POINTER=1 -DHAVE_LIBM=1 -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DSIZEOF_UNSIGNED_LONG_LONG_INT=8 -DSIZEOF_UNSIGNED_LONG_INT=8 -DSIZEOF_UNSIGNED_INT=4 -DSIZEOF_UNSIGNED_SHORT=2 -DHAVE_MKSTEMP=1 -DHAVE_VALLOC=1 -DHAVE_MEMALIGN=1 -DHAVE_INET_PTON=1 -DUSE_LLU=1   -I.  -I/usr/local/include -I. -I../pcap -I/usr/include/pcap   -c -o print.o print.c                                                                                   
print.c: In function 'printtcp_packet':                                                                                                                       
print.c:380: error: 'struct tcphdr' has no member named 'th_off'                                                                                              
print.c:387: error: 'struct tcphdr' has no member named 'th_sport'                                                                                            
print.c:388: error: 'struct tcphdr' has no member named 'th_sport'                                                                                            
print.c:390: error: 'struct tcphdr' has no member named 'th_dport'                                                                                            
print.c:391: error: 'struct tcphdr' has no member named 'th_dport'                                                                                            
print.c:393: error: 'struct tcphdr' has no member named 'th_flags'                                                                                            
print.c:394: error: 'struct tcphdr' has no member named 'th_flags'                                                                                            
print.c:395: error: 'struct tcphdr' has no member named 'th_flags'                                                                                            
print.c:395: error: 'TH_URG' undeclared (first use in this function)                                                                                          
print.c:395: error: (Each undeclared identifier is reported only once                                                                                         
print.c:395: error: for each function it appears in.)                                                                                                         
print.c:396: error: 'struct tcphdr' has no member named 'th_flags'                                                                                            
print.c:396: error: 'TH_ACK' undeclared (first use in this function)                                                                                          
print.c:397: error: 'struct tcphdr' has no member named 'th_flags'                                                                                            
print.c:397: error: 'TH_PUSH' undeclared (first use in this function)                                                                                         
print.c:398: error: 'struct tcphdr' has no member named 'th_flags'                                                                                            
print.c:398: error: 'TH_RST' undeclared (first use in this function)                                                                                          
print.c:399: error: 'struct tcphdr' has no member named 'th_flags'                                                                                            
print.c:399: error: 'TH_SYN' undeclared (first use in this function)                                                                                          
print.c:400: error: 'struct tcphdr' has no member named 'th_flags'                                                                                            
print.c:400: error: 'TH_FIN' undeclared (first use in this function)                                                                                          
print.c:401: error: 'struct tcphdr' has no member named 'th_flags'                                                                                            
print.c:402: error: 'struct tcphdr' has no member named 'th_seq'                                                                                              
print.c:403: error: 'struct tcphdr' has no member named 'th_ack'                                                                                              
print.c:404: error: 'struct tcphdr' has no member named 'th_win'
print.c:405: error: 'struct tcphdr' has no member named 'th_off'
print.c:406: error: 'struct tcphdr' has no member named 'th_off'
print.c:413: error: 'struct tcphdr' has no member named 'th_x2'
print.c:415: error: 'struct tcphdr' has no member named 'th_x2'
print.c:417: error: 'struct tcphdr' has no member named 'th_sum'
print.c:418: error: 'struct tcphdr' has no member named 'th_off'
print.c:439: error: 'struct tcphdr' has no member named 'th_off'
print.c:443: error: 'struct tcphdr' has no member named 'th_off'
print.c:444: error: 'struct tcphdr' has no member named 'th_off'
print.c:503: error: 'struct tcphdr' has no member named 'th_off'
print.c: In function 'printudp_packet':
print.c:535: error: 'struct udphdr' has no member named 'uh_sport'
print.c:536: error: 'struct udphdr' has no member named 'uh_sport'
print.c:538: error: 'struct udphdr' has no member named 'uh_dport'
print.c:539: error: 'struct udphdr' has no member named 'uh_dport'
print.c:541: error: 'struct udphdr' has no member named 'uh_ulen'
print.c:543: error: 'struct udphdr' has no member named 'uh_sum'
print.c:552: error: 'struct udphdr' has no member named 'uh_ulen'
print.c:553: error: 'struct udphdr' has no member named 'uh_ulen'
print.c:556: error: 'struct udphdr' has no member named 'uh_ulen'
make: *** [print.o] Error 1
make: *** Waiting for unfinished jobs....
 * ERROR: net-analyzer/tcptrace-6.6.7 failed:
 *   emake failed
 *
 * Call stack:
 *     ebuild.sh, line  48:  Called src_compile
 *   environment, line 270:  Called _eapi0_src_compile
 *     ebuild.sh, line 606:  Called _eapi2_src_compile
 *     ebuild.sh, line 640:  Called die
 * The specific snippet of code:
 *              emake || die "emake failed"
 *
 * If you need support, post the output of 'emerge --info =net-analyzer/tcptrace-6.6.7',
 * the complete build log and the output of 'emerge -pqv =net-analyzer/tcptrace-6.6.7'.
 * The complete build log is located at '/var/log/portage/net-analyzer:tcptrace-6.6.7:20100624-002129.log'.
 * The ebuild environment file is located at '/var/tmp/portage/net-analyzer/tcptrace-6.6.7/temp/environment'.
 * S: '/var/tmp/portage/net-analyzer/tcptrace-6.6.7/work/tcptrace-6.6.7'


Reproducible: Always

Steps to Reproduce:
1.emerge -1e world / emerge -1 tcptrace
2.
3.

Actual Results:  
See description, the build fails with all kinds of "has no member..."
So the tool appearantly doesn't fit the libpcap headers etc.
AFAICT Upstream died some time ago.

Expected Results:  
Working tcptrace
Comment 1 Nico Baggus 2010-06-24 00:30:45 UTC
Portage 2.2_rc67 (default/linux/amd64/10.0/desktop, gcc-4.4.4, glibc-2.11.1-r0, 2.6.32-gentoo-r7 x86_64)
=================================================================                                       
System uname: Linux-2.6.32-gentoo-r7-x86_64-AMD_Athlon-tm-_II_Dual-Core_M300-with-gentoo-2.0.1          
Timestamp of tree: Tue, 22 Jun 2010 18:00:22 +0000                                                      
distcc 3.1 x86_64-pc-linux-gnu [disabled]                                                               
ccache version 2.4 [disabled]                                                                           
app-shells/bash:     4.0_p37                                                                            
dev-java/java-config: 2.1.10                                                                            
dev-lang/python:     2.6.5-r2, 3.1.2-r3                                                                 
dev-util/ccache:     2.4-r7                                                                             
dev-util/cmake:      2.8.1-r1                                                                           
sys-apps/baselayout: 2.0.1                                                                              
sys-apps/openrc:     0.6.1-r1                                                                           
sys-apps/sandbox:    2.2                                                                                
sys-devel/autoconf:  2.13, 2.65                                                                         
sys-devel/automake:  1.4_p6-r1, 1.7.9-r2, 1.8.5-r4, 1.9.6-r3, 1.10.3, 1.11.1                            
sys-devel/binutils:  2.20.1-r1                                                                          
sys-devel/gcc:       4.3.4, 4.4.4                                                                       
sys-devel/gcc-config: 1.4.1                                                                             
sys-devel/libtool:   2.2.6b                                                                             
virtual/os-headers:  2.6.30-r1                                                                          
ACCEPT_KEYWORDS="amd64"                                                                                 
ACCEPT_LICENSE="* -@EULA PUEL sun-bcla-java-vm dlj-1.1 skype-eula googleearth AdobeFlash-10 AdobeFlash-10.1"
CBUILD="x86_64-pc-linux-gnu"                                                                                
CFLAGS="-O2 -pipe -mno-tls-direct-seg-refs -g "                                                             
CHOST="x86_64-pc-linux-gnu"                                                                                 
CONFIG_PROTECT="/etc /opt/openfire/resources/security/ /usr/share/X11/xkb /usr/share/config /var/bind /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/env.d/java/ /etc/eselect/postgresql /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5/ext-active/ /etc/php/cgi-php5/ext-active/ /etc/php/cli-php5/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -pipe -mno-tls-direct-seg-refs -g "
DISTDIR="/mnt/floppy/var-tmp/"
FEATURES="assume-digests distlocks fixpackages news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unmerge-logs unmerge-orphans userfetch userpriv usersandbox"
GENTOO_MIRRORS="ftp://212.219.56.134/sites/www.ibiblio.org/gentoo/ http://mirror.cambrium.nl/pub/os/linux/gentoo/ http://ftp.twaren.net/Linux/Gentoo/"
LDFLAGS="-Wl,-O1"
LINGUAS="en_GB en_US nl_NL nl en"
MAKEOPTS="-j3"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_EXTRA_OPTS="--exclude ChangeLog --delete-excluded"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/var/lib/layman/java-overlay /var/lib/layman/voip /var/lib/layman/webapps-experimental /var/lib/layman/openmoko /var/lib/layman/sunrise /var/lib/layman/kde /usr/local/portage"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="3dnow 3dnowext X X509 a52 aac aalib accessibility acl acpi activefilter ads aio akode alsa amd64 ao apache2 ati audiofile audit authdaemond automount avahi bash-completion berkdb bl bluetooth bookmarks branding bzip2 cairo caps cdda cddb cdparanoia cdr cgi chm cleartype cli consolekit cracklib crypt cscope css cups curl cxx dbus dga directfb djvu dri dts dv dvb dvd dvdr eap-tls emboss encode esd exif exiscan exiscan-acl expat fam fame fastcgi fax fbcon ffmpeg firefox flac foomaticdb fortran fpx frxp gd gdbm ggi gif gimp glib gmp gnokii gphoto2 gpm graphviz gs gsm gstreamer gtk guile hal handbook howl-compat hpn html http httpd ical icecast iconv id3 id3tag idn ieee1394 ilbc imap imlib ipv6 irda ithreads jabber jack java javascript jbig jingle joystick jpeg jpeg2k justify kde kerberos kipi kqemu ladspa lame laptop lcms ldap libcaca libnotify libsamplerate live lm_sensors lmtp loop-aes lua lzma lzo mad mailwrapper matroska mbrola md5sum mdnsresponder-compat memcache mhash mikmod mjpeg mmap mmx mmxext mng modules motif mp2 mp3 mp4 mpeg mplayer mudflap multilib musepack musicbrainz mysql nagios-dns nagios-game nagios-ntp nagios-ping nagios-ssh nas ncurses netboot network nls nptl nptlonly nsplugin obex odbc odk ogg openal openexr opengl openmp oscar oss pam pango pcre pda pdf perl php pic plotutils png pnm policykit portaudio postscript ppds pppd pth pulseaudio python qt3 qt3support qt4 quicktime quotas radius rar rdesktop readline reflection rle rrdtool rtc ruby samba sasl scanner sdl semantic-desktop server session skey slang sndfile snmp span speex spell spf spl sqlite sqlite3 srs sse sse2 sse3 sse4a ssl startup-notification subversion svg swat symlink sysfs syslog tcpd theora threads tiff timidity tools truetype tta unicode ups urandom usb utempter v4l v4l2 vcd vde vim-syntax vnc vorbis wavpack webdav wifi winbind wma wmf x264 xanim xattr xcb xfs xine xinerama xml xmlreader xmlrpc xmlwriter xorg xosd xpm xscreensaver xulrunner xv xvid xvmc yaz yv12 zeroconf zip zlib zrtp" ALSA_CARDS="hda-intel usb-audio" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" APACHE2_MPMS="peruser" CAMERAS="ptp2 canon casio" ELIBC="glibc" INPUT_DEVICES="evdev keyboard mouse synaptics joystick" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="en_GB en_US nl_NL nl en" QEMU_SOFTMMU_TARGETS="arm i386 alpha x86_64" QEMU_USER_TARGETS="alpha i386 x86_64 arm armeb" RUBY_TARGETS="ruby18" USERLAND="GNU" VIDEO_CARDS="radeon radeonhd vesa vga fbdev" XTABLES_ADDONS="geoip iface ipmark ipp2p ipset ipv4options pknock tarpit tee rawnat steal condition"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, FFLAGS, INSTALL_MASK, LANG, LC_ALL, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS
Comment 2 Jeroen Roovers (RETIRED) gentoo-dev 2010-07-01 17:46:25 UTC
What if you removed "-mno-tls-direct-seg-refs" from CFLAGS (as well as the extraneous space at the end of the variable)? I don't think we support this officially so if that turns out to solve the issue, then this bug isn't valid.
Comment 3 Nico Baggus 2010-07-01 22:41:08 UTC
-mno-tls-direct-seg-refs  is needed if I want to run with XEN.
and has nothing to do with includes. Sorry.. This is changes in structures somewhere.. (besides I have the -mno-tls... in there for about 2.5-3 years now.)
It also requires an emerge -e to resolve completely, so for now no thank you on that one. (I just had an emerge -e  done to get rid of some annoying incompatible libraries and there are other things to repair still. So i hadn't investigated it further)

Now there is a README.linux in the top level directory after unpacking...
and that even describes the solution.... (Now I do have glibc-2 for quite some time and about a year ago it did compile).

---8<---
>> Subject: Re: tcptrace
>> 
>> On Linux with glibc-2 it needs 
>> 
>> DEFINES += -D_BSD_SOURCE
>> 
>> to build properly.
>> 
>> It's simply a matter of which "style" of tcphdr struct naming is
>> pulled in from the include files.
>> 
>> From memory the "-D_BSD_SOURCE" is safe for older Linux setups as
>> well, however I can't test it.
>>
>> Peter
---8<---

Indeed adding the -D to the make file causes an almost clean build.
Comment 4 Jeroen Roovers (RETIRED) gentoo-dev 2010-07-26 22:57:05 UTC
I can't reproduce this on a regular system, and I keep seeing the same QA warnings, but I have applied it (append-flags -DBSD_Source) anyway.
Comment 5 Nico Baggus 2010-07-27 21:13:41 UTC
It is now compiling again without faults.
Thanks.